#include "userprog/syscall.h"
#include <stdio.h>
#include <syscall-nr.h>
#include "threads/interrupt.h"
#include "threads/thread.h"

static void syscall_handler (struct intr_frame *);

void
syscall_init (void) 
{
  intr_register_int (0x30, 3, INTR_ON, syscall_handler, "syscall");
}
/* from lib/syscall-nr.h 
system calls numbers are 
    SYS_HALT,                  0
    SYS_EXIT,                  1
    SYS_EXEC,                  2 
    SYS_WAIT,                  3 
    SYS_CREATE,                4
    SYS_REMOVE,                5
    SYS_OPEN,                  6
    SYS_FILESIZE,              7
    SYS_READ,                  8
    SYS_WRITE,                 9
    SYS_SEEK,                  10
    SYS_TELL,                  11
    SYS_CLOSE,                 12

these are used for the case instead of number
*/

static void
syscall_handler (struct intr_frame *f UNUSED)
{
  printf ("system call!\n");
  int syscall_nr=-1;
  switch(syscall_nr) {
	  case SYS_HALT:{
		  printf ("system call, halt\n");
		      shutdown_power_off();
		  break;
    }
    /*
    // each team member should select on syscall.
    // develop one from the cw document


    case SYS_EXIT:{
      //to be developed
      break;
    }
    case SYS_EXEC:{
      //to be developed
      break;
    }
    case SYS_WAIT:{
      //to be developed
      break;
    }
    case SYS_WAIT:{
      //to be developed
      break;
    }
    */

    case SYS_OPEN: { //calls at point=6
  // Retrieve the actual file name argument from the user program's stack to be opened
  // this line of code will not work if our team membre did not finish the stack code
  const char* file_name = (const char*) get_user((const uint8_t*)f->esp + 4);

  // Check if the file name pointer is valid and accessible
  if (!file_name || !is_user_vaddr(file_name)) {
    thread_exit(); // Terminate the thread if the pointer is invalid
  }

  // Open the file using the file system
  struct file* file_obj = filesys_open(file_name);

  // Check if the file opening was successful
  if (!file_obj) {
    f->eax = -1; // Return -1 to indicate failure
  } else {
   
    int fd = process_add_file(file_obj);
    // Return the file descriptor to the user program 
    f->eax = fd;
  }

  break;
}
  thread_exit ();
}
}
